


absorber       = [0.2 0.4 0.6 0.7 0.8 0.9 1.0 1.2 ...
                   1.4 1.6 1.8 2.0 2.5 3.0 4.0 6.0];

save_mat = 0;
load_mat = 1;


use_eke_bl = 0;

if load_mat == 1
  load rad_vs_diff_enflux_changectl.mat
else

  rf_exp = 'fixedsst_idealized_moist_forcing/sstabs';
  exper_base = 'inst_rf_idealized_moist/abs';

  % first consider ref and abs1.4 to define warming pattern
  % and other quantities shown specifically for that difference
  ref_ind = 7;

  rf_exp = 'fixedsst_idealized_moist_forcing/sstabs';
  ref_exper_rf = [rf_exp '1.0_radabs1.0'];

  exper_base = 'inst_rf_idealized_moist/abs';
  ref_exper = [exper_base '1.0_rf1.0'];
  ts_gl_ref = global_surf_temp(ref_exper);

  [files, eopts]   = experiment(ref_exper);
  lat              = get_avg_field(files{1}, 'lat');
  w = weight_function(lat,-90,90);
  
  warm_ind = ref_ind + 2; % abs1.4
  exper = [exper_base , num2str(absorber(warm_ind), '%1.1f') '_rf1.0'];  
  exper_rf = [rf_exp '1.0_radabs' num2str(absorber(warm_ind), '%1.1f')];  
  [total_fdbk_ref, planck_fdbk_ref, lr_fdbk_ref, rf_ref, dNtoa_ref, dsat_ref, Ntoa_ref] = ...
  get_gray_feedbacks(ref_exper,exper, ref_exper_rf, exper_rf);

  enflux_fromtoa_ref = toarad_to_enflux(dNtoa_ref,lat);
  enflux_planck_ref = toarad_to_enflux(planck_fdbk_ref.*dsat_ref,lat);
  enflux_lr_ref = toarad_to_enflux(lr_fdbk_ref.*dsat_ref,lat);
  enflux_rf_ref = toarad_to_enflux(rf_ref,lat);
  enflux_fdbk_ref = toarad_to_enflux(total_fdbk_ref.*dsat_ref,lat);

  enflux_planck_uniwarming_ref = toarad_to_enflux(planck_fdbk_ref*(dsat_ref*w),lat);
  enflux_lr_uniwarming_ref = toarad_to_enflux(lr_fdbk_ref*(dsat_ref*w),lat);

  addpath lr_gray_ma/;
  [lat_lr,lambda_lr_ma] = get_ma_lr_fdbk_param;
  enflux_lr_ma_uniwarming_ref = toarad_to_enflux(lambda_lr_ma * (dsat_ref*w),lat);

  [tmp,dN_mebm_planck, dT_est, lambda_P_est] = get_mebm_planck_flux;
  enflux_planck_mebm_est_ref = toarad_to_enflux(dN_mebm_planck * (dsat_ref*w),lat);


  % loop over all abs
  nexper = length(absorber)-1;

  for i=1:nexper

    ref_exper = [exper_base , num2str(absorber(i), '%1.1f') '_rf1.0']
    exper = [exper_base , num2str(absorber(i+1), '%1.1f') '_rf1.0'];

    % adjusted forcing simulations
    exper_rf = [rf_exp num2str(absorber(i), '%1.1f') '_radabs' num2str(absorber(i+1), '%1.1f')]
    ref_exper_rf = [rf_exp num2str(absorber(i), '%1.1f') '_radabs' num2str(absorber(i), '%1.1f')]


    [files, eopts]   = experiment(exper_rf);
    lat              = get_avg_field(files{1}, 'lat');
    latind = max(find(lat<50));

    sigma            = get_avg_field(files{1}, 'sigma');
  
    [files, eopts]   = experiment(ref_exper);
    Tatm             = get_avg_field(files, 'temp');
    sat_ref          = squeeze(Tatm(end,:));
    
    % this function is partly redundant with the get_gray_feedbacks
    % which returns the total mse flux from TOA budget
    % ie. the following function is only needed for the Lq,dse partition
    [lat, mse_flux(i,:), latent_flux(i,:), mean_mse_flux, mean_latent_flux] = ...
    get_energy_flux_vs_lat(ref_exper);
    [lat, mse_flux(i+1,:), latent_flux(i+1,:), mean_mse_flux, mean_latent_flux] = ...
    get_energy_flux_vs_lat(exper);

    ts_gl(i) = global_surf_temp(ref_exper);
    ts_gl(i+1) = global_surf_temp(exper);

    % forcing feedback decomposition
    [total_fdbk, planck_fdbk, lr_fdbk, rf_lat(i,:), dNtoa, dsat, Ntoa_ref] = ...
      get_gray_feedbacks(ref_exper,exper, ref_exper_rf, exper_rf);
    [total_fdbk_all(i,:), planck_fdbk_all(i,:), lr_fdbk_all(i,:), rf, dNtoa_all(i,:), dsat_all(i,:), Ntoa_ref_all(i,:)] = ...
      get_gray_feedbacks(ref_exper,exper, ref_exper_rf, exper_rf);

    enflux_ref_fromtoa(i,:) = toarad_to_enflux(Ntoa_ref_all(i,:),lat);
    enflux_fromtoa(i,:) = toarad_to_enflux(dNtoa_all(i,:),lat);
    
    enflux_rf(i,:) = toarad_to_enflux(rf_lat(i,:),lat);
    enflux_fdbk(i,:) = toarad_to_enflux(total_fdbk.*dsat,lat);
    enflux_planck(i,:) = toarad_to_enflux(planck_fdbk.*dsat,lat);
    enflux_lr(i,:) = toarad_to_enflux(lr_fdbk.*dsat,lat);

    enflux_lr_uniwarming(i,:) = toarad_to_enflux(lr_fdbk * (dsat*w),lat);

    enflux_lr_fixedpatternwarming(i,:) = ...
    toarad_to_enflux(lr_fdbk .* dsat_ref *(ts_gl(i+1)-ts_gl(i))/(dsat_ref*w) ,lat);
  
    enflux_planck_uniwarming(i,:) = toarad_to_enflux(planck_fdbk * (dsat*w),lat);

    enflux_planck_fixedpatternwarming(i,:) = ...
    toarad_to_enflux(planck_fdbk .* dsat_ref *(ts_gl(i+1)-ts_gl(i))/(dsat_ref*w) ,lat);

    enflux_lr_ma_uniwarming(i,:) = toarad_to_enflux(lambda_lr_ma * (dsat*w),lat);

    enflux_planck_mebm_est(i,:) = toarad_to_enflux(dN_mebm_planck * (dsat*w),lat);
  
    % diffusive closure
    [mse_flux_diff(i), mse_flux_diff2(i), veddy(i),mean_grad_comp(i), ...
     mean_grad_comp_dry(i),eke_lat(i), delT(i), qsat_ref(i), ...
     beta(i), rh_subtrop(i), gamma(i)] = ...
      bischoff14_diff_closure(ref_exper,use_eke_bl);
    [mse_flux_diff(i+1), mse_flux_diff2(i+1), veddy(i+1),mean_grad_comp(i+1), ...
     mean_grad_comp_dry(i+1),eke_lat(i+1), delT(i+1), qsat_ref(i+1), ...
     beta(i+1), rh_subtrop(i+1), gamma(i+1)] = ...
      bischoff14_diff_closure(exper,use_eke_bl);
  
    % simple diffusive closure
    diff_flux_simple_vs_lat(i,:) = mse_diff_closure_simple(ref_exper);
    diff_flux_simple_vs_lat(i+1,:) = mse_diff_closure_simple(exper);

    % evaluted as lat 20 -70 difference
    diff_flux_simple_xt_diff(i) = mse_diff_closure_simple(exper,1);

  end    
  dts_gl = ts_gl-ts_gl(ref_ind);
  dsat_gl_all = ts_gl(:)-ts_gl(ref_ind);

  % load CMIP5 results from netcdf                                  
  infilename = 'feldl_cmip5_feedbacks_june2020.nc';

  ncid  = netcdf.open(infilename,'NC_NOWRITE');
  
  varid = netcdf.inqVarID(ncid, 'lat');
  lat_cmip5 = netcdf.getVar(ncid, varid);
  
  varid = netcdf.inqVarID(ncid, 'model');
  model_inds = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'dts_zm_norm');
  dT_cmip5_norm = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'dts_zm');
  dT_cmip5 = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'dts_gm');
  dT_gm_cmip5 = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'planck_fdbk');
  planck_cmip5 = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'lapse_fdbk');
  lapse_cmip5 = netcdf.getVar(ncid, varid);

  netcdf.close(ncid);

  for i=1:length(model_inds)
    planck_trans_cmip5(:,i) = toarad_to_enflux( (planck_cmip5(:,i).*dT_cmip5(:,i))',lat_cmip5)/dT_gm_cmip5(i);
    lapse_trans_cmip5(:,i) = toarad_to_enflux((lapse_cmip5(:,i).*dT_cmip5(:,i))',lat_cmip5)/dT_gm_cmip5(i);
  end


  % load CAM3
  infilename = 'RC_feedback_dsat_vs_lat_widerange_CAM3_pd_aug232021.nc';
  
  ncid  = netcdf.open(infilename,'NC_NOWRITE');

  varid = netcdf.inqVarID(ncid, 'lat');
  lat_cam3 = netcdf.getVar(ncid, varid);
  
  varid = netcdf.inqVarID(ncid, 'co2');
  co2_cam3 = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'temp change');
  dT_cam3 = netcdf.getVar(ncid, varid);
  
  varid = netcdf.inqVarID(ncid, 'total');
  total_fdbk_cam3 = netcdf.getVar(ncid, varid);

  varid = netcdf.inqVarID(ncid, 'lapse rate');
  lapse_cam3 = netcdf.getVar(ncid, varid);
  
  varid = netcdf.inqVarID(ncid, 'global mean Ts');
  ts_gl_cam3 = netcdf.getVar(ncid, varid);

  netcdf.close(ncid);

  if save_mat
    save rad_vs_diff_enflux_changectl.mat
  end

end

  

gray = [0.6 0.6 0.6];

if 1
% ---------
%  Fig. 1 two vertical panel energy comps latent, DSE and simple diffusive 
% ---------


clf; init_figure;
fwidth          = 6.5/2;
fheight         = fwidth*1.0 / 1.618*2;
loff            = 0.18;
roff            = 0.04;
boff            = .12;
toff            = .02;
hdist           = 0.13;
cbar_width      = 0.0;
vdist           = 0.06;
panel_width     = (1-roff-loff-0*hdist)/1;
panel_height    = (1-boff-toff-1*vdist)/2;

set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');



subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,mse_flux(:,latind),'ko-')
hold on;
plot(ts_gl,latent_flux(:,latind),'b-.')
plot(ts_gl,mse_flux(:,latind)-latent_flux(:,latind),'r--')
plot(ts_gl(ref_ind),mse_flux(ref_ind,latind),'ko','markerfacecolor','k')
axis([255 320 0 5.5])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:1:5])
text(243,5.5,'a','fontweight','bold','fontsize',11);
ylabel('Energy Transport (PW)','fontweight','bold')
legend('GCM','Lq','Dry','location','nw');  legend boxoff;


subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,mse_flux(:,latind),'ko-')
hold on;
plot(ts_gl,diff_flux_simple_vs_lat(:,latind),':','color',gray)
plot(ts_gl(ref_ind),mse_flux(ref_ind,latind),'ko','markerfacecolor','k')
axis([255 320 0 5.5])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:1:5])
text(243,5.5,'b','fontweight','bold','fontsize',11);
ylabel('Energy Transport (PW)','fontweight','bold')
xlabel('Surface Temperature (K)','fontweight','bold')
legend('GCM','Simple diffusive','location','SE'); legend boxoff;

print -depsc rad_vs_diff_figs/fig1.eps
%return
end



if 1

%--------------------------------------------------------------------
% Fig. 2 forcing feedback vs lat near control 
% abs1.4-abs1.0
%--------------------------------------------------------------------
  

clf; init_figure;
fwidth          = 6.5;
fheight         = fwidth / 1.618*1.1*1.5;
loff            = 0.11;
roff            = 0.02;
boff            = .07;
toff            = .06;
hdist           = 0.09;
cbar_width      = 0.0;
vdist           = hdist * fwidth / fheight *0.6;
panel_width     = (1-roff-loff-1*hdist)/2;
panel_height    = (1-boff-toff-2*vdist)/3;

set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');




ymaxtoa = 7;
ymintoa = -7;
ymaxflux = 0.1;
yminflux = -0.1;

% GCM, forcing, and feedback: energy transport
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );


dsat_gl = ts_gl(warm_ind)-ts_gl(ref_ind);

%plot(lat,(mse_flux(warm_ind,:)-mse_flux(ref_ind,:))./dsat_gl,'k-')
plot(lat,enflux_fromtoa_ref./dsat_gl,'k-')
hold on;

plot(lat,enflux_rf_ref./dsat_gl,'b-')
plot(lat,enflux_fdbk_ref./dsat_gl,'c-')
plot(lat, zeros(size(lat)),'k:');

axis([-90 90 yminflux ymaxflux])
title('Energy Transport','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''})
%grid on;
ylabel('PW K^{-1}','fontweight','bold')
text(-122,0.11,'a','fontweight','bold','fontsize',11);
legend('GCM','','\lambda','location','nw'); legend boxoff;
h=text(-49,0.058,'$\mathcal{F}$','fontsize',10); set(h,'Interpreter','latex');

% GCM, forcing, and feedback: NTOA
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,(rf_ref+(total_fdbk_ref).*dsat_ref)./dsat_gl,'k');

hold on;
plot(lat,rf_ref./dsat_gl,'b');
plot(lat,(total_fdbk_ref.*dsat_ref)./dsat_gl,'c');

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 ymintoa ymaxtoa])
title('Normalized TOA Flux','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''})

text(-122,7.67,'b','fontweight','bold','fontsize',11);
ylabel('W m^{-2} K^{-1}','fontweight','bold')

% LR vs Planck feedback: energy transport
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,(enflux_planck_ref)./dsat_gl,'m-')
hold on;
plot(lat,(enflux_lr_ref)./dsat_gl,'r-')
plot(lat,(enflux_lr_uniwarming_ref)./dsat_gl,'r--')
plot(lat,(enflux_planck_uniwarming_ref)./dsat_gl,'m--')

plot(lat, zeros(size(lat)),'k:');

axis([-90 90 yminflux ymaxflux])
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''})
ylabel('PW K^{-1}','fontweight','bold')
text(-122,0.11,'c','fontweight','bold','fontsize',11);

% LR vs Planck feedback: NTOA
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,(planck_fdbk_ref.*dsat_ref)./dsat_gl,'m');
hold on;
plot(lat,(lr_fdbk_ref.*dsat_ref)./dsat_gl,'r');

plot(lat,lr_fdbk_ref,'r--');
plot(lat,planck_fdbk_ref,'m--');
plot(lat, zeros(size(lat)),'k:');

axis([-90 90 ymintoa ymaxtoa])
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''})
ylabel('W m^{-2} K^{-1}','fontweight','bold')
legend('Planck','Lapse Rate','location','n'); legend boxoff;
text(-122,7.67,'d','fontweight','bold','fontsize',11);

% LR vs Planck feedback with GCM ind: energy transport
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat, zeros(size(lat)),'k:');
hold on;
plot(lat,(enflux_planck_ref)./dsat_gl,'m-')
hold on;
plot(lat,(enflux_lr_ref)./dsat_gl,'r-')
plot(lat,(enflux_lr_ma_uniwarming_ref)./dsat_gl,'r:');
plot(lat,(enflux_planck_mebm_est_ref)./dsat_gl,'m:');
a = (enflux_planck_mebm_est_ref)./dsat_gl;
b = (enflux_lr_ma_uniwarming_ref)./dsat_gl;
c = (enflux_fdbk_ref)./dsat_gl;
plot(lat,a+b,'c:','linewidth', 1.6);
hold on;
plot(lat,c,'c-');

axis([-90 90 yminflux ymaxflux])
set(gca,'box','off','xtick',[-90:30:90]);
ylabel('PW K^{-1}','fontweight','bold')
xlabel('Latitude','fontweight','bold')
text(-122,0.11,'e','fontweight','bold','fontsize',11);

% LR vs Planck feedback with GCM ind: NTOA
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,(planck_fdbk_ref.*dsat_ref)./dsat_gl,'m');
hold on;
plot(lat,(lr_fdbk_ref.*dsat_ref)./dsat_gl,'r');

plot(lat,lambda_lr_ma,'r:');
plot(lat,dN_mebm_planck,'m:');

plot(lat, zeros(size(lat)),'k:');

axis([-90 90 ymintoa ymaxtoa])
set(gca,'box','off','xtick',[-90:30:90]);
ylabel('W m^{-2} K^{-1}','fontweight','bold')
xlabel('Latitude','fontweight','bold')
legend('Planck','Lapse Rate','location','n'); legend boxoff;
text(-122,7.67,'f','fontweight','bold','fontsize',11);

print -depsc rad_vs_diff_figs/fig2.eps
end


if 1

%--------------------------------------------------------------------     
% Fig. 3 CMIP5 and near control warming pattern and feedbacks vs lat   
% abs1.4-abs1.0
%--------------------------------------------------------------------        

clf; init_figure;
fwidth          = 6.5;
fheight         = fwidth / 1.618*3/2;
loff            = 0.07;
roff            = 0.015;
boff            = .07;
toff            = .04;
hdist           = 0.1;
cbar_width      = 0.0;
vdist           = hdist * fwidth / fheight*.6;
panel_width     = (1-roff-loff-1*hdist)/2;
panel_height    = (1-boff-toff-2*vdist)/3;


set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');


ymaxtoa = 6;
ymintoa = -8;
ymaxflux = 2.5;
yminflux = -4;

% top left panel planck parameter
subplot('Position', [loff,...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,planck_fdbk_ref,'m-');
hold on;

plot(lat_cmip5,mean(planck_cmip5,2),'k-.')
for i=1:length(model_inds)
  plot(lat_cmip5,planck_cmip5(:,i),'-','color',gray,'linewidth',0.2)
end
plot(lat_cmip5,mean(planck_cmip5,2),'k-.')

legend('Gray','CMIP5 ens. mean','CMIP5 ind. model','location','northeast');
legend boxoff;
axis([-90 90 -4.5 -.5])
text(-110,-.32,'a','fontweight','bold','fontsize',11);
title('Planck Feedback','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
ylabel('W m^{-2} K^{-1}','fontweight','bold')
                               %xlabel('Latitude','fontweight','bold')          

% top right panel planck transport                                      
subplot('Position', [loff+panel_width+hdist,...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

dsat_gl = ts_gl(warm_ind)-ts_gl(ref_ind);

plot(lat,enflux_planck_ref./dsat_gl,'m-');
hold on;

plot(lat,enflux_planck_mebm_est_ref/dsat_gl,'k--');
plot(lat_cmip5,mean(planck_trans_cmip5,2),'k-.')

for i=1:length(model_inds)
  plot(lat_cmip5,planck_trans_cmip5(:,i),'-','color',gray,'linewidth',0.2)
end
plot(lat_cmip5,mean(planck_trans_cmip5,2),'k-.')
plot(lat_cmip5,0*mean(lapse_cmip5,2),'k:')
plot(lat,enflux_planck_ref./dsat_gl,'m-');
plot(lat,enflux_planck_mebm_est_ref/dsat_gl,'k--');


legend('Gray','MEBM est','location','southeast');
legend boxoff;
axis([-90 90 -.22 .22])
text(-110,.24,'b','fontweight','bold','fontsize',11);
title('Planck Feedback Transport','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
ylabel('PW K^{-1}','fontweight','bold')


% middle left lapse rate feedback parameter
subplot('Position', [loff,...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(lat,lr_fdbk_ref,'r-')
hold on;
plot(lat_cmip5,mean(lapse_cmip5,2),'k-.')
for i=1:length(model_inds)
  plot(lat_cmip5,lapse_cmip5(:,i),'-','color',gray,'linewidth',0.2)
end
plot(lat_cmip5,mean(lapse_cmip5,2),'k-.')
plot(lat_cmip5,0*mean(lapse_cmip5,2),'k:')
plot(lat,lr_fdbk_ref,'r-')

legend('Gray','CMIP5 ens. mean','CMIP5 ind. model','location','southeast');
legend boxoff;

axis([-90 90 -5.8 1.2])
text(-110,1.52,'c','fontweight','bold','fontsize',11);
title('Lapse Rate Feedback','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
set(gca,'ytick',[-5:1:1]);
ylabel('W m^{-2} K^{-1}','fontweight','bold')


% middle right panel lapse rate transport                             
subplot('Position', [loff+panel_width+hdist,...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

dsat_gl = ts_gl(warm_ind)-ts_gl(ref_ind);

plot(lat,enflux_lr_ref/dsat_gl,'r-');
hold on;

plot(lat,enflux_lr_ma_uniwarming_ref/dsat_gl,'k--');
plot(lat_cmip5,mean(lapse_trans_cmip5,2),'k-.')

for i=1:length(model_inds)
  plot(lat_cmip5,lapse_trans_cmip5(:,i),'-','color',gray,'linewidth',0.2)
end
plot(lat_cmip5,0*mean(lapse_cmip5,2),'k:')
plot(lat_cmip5,mean(lapse_trans_cmip5,2),'k-.')
plot(lat,enflux_lr_ref/dsat_gl,'r-');
plot(lat,enflux_lr_ma_uniwarming_ref/dsat_gl,'k--');


legend('Gray','Moist Adiabat est','location','southwest');
legend boxoff;
axis([-90 90 -.22 .22])
text(-110,.24,'d','fontweight','bold','fontsize',11);
title('Lapse Rate Feedback Transport','fontweight','bold');
ylabel('PW K^{-1}','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90]);
xlabel('Latitude','fontweight','bold')

% bottom dT pattern                                                    
subplot('Position', [loff,...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

dsat_gl = ts_gl(ref_ind+2)-ts_gl(ref_ind);

plot(lat,dsat_ref./dsat_gl,'k-');
hold on;
plot(lat,dT_est,'k--');

plot(lat_cmip5,mean(dT_cmip5_norm,2),'k-.')
for i=1:length(model_inds)
  plot(lat_cmip5,dT_cmip5_norm(:,i),'-','color',gray,'linewidth',0.2)
end
plot(lat_cmip5,mean(dT_cmip5_norm,2),'k-.')
plot(lat,dT_est,'k--');
plot(lat,dsat_ref./dsat_gl,'k-');

h=legend('Gray','EBM','CMIP5 ens. mean','CMIP5 ind. model','location','nw'); legend boxoff;

axis([-90 90 0 4])
text(-110,4.18,'e','fontweight','bold','fontsize',11);

title('Temperature Change','fontweight','bold')
set(gca,'box','off','xtick',[-90:30:90]);
set(gca,'ytick',[0:1:5])

ylabel('K K^{-1}','fontweight','bold')
xlabel('Latitude','fontweight','bold')


print -depsc rad_vs_diff_figs/fig3.eps

end


if 1

%--------------------------------------------------------------------     
% Fig. 4 energetic evaluation for wide range of gray climates
%--------------------------------------------------------------------        

clf; init_figure;
fwidth          = 6.5;
fheight         = fwidth / 1.618*1.1;
loff            = 0.09;
roff            = 0.02;
boff            = .11;
toff            = .06;
hdist           = 0.08;
cbar_width      = 0.0;
vdist           = hdist * fwidth / fheight *0.8;
panel_width     = (1-roff-loff-1*hdist)/2;
panel_height    = (1-boff-toff-1*vdist)/2;

set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');


%--------------------------------------------------------------------
%  forcing feedback
%--------------------------------------------------------------------
ymax = 2.4;
ymin = -3.4;

% GCM, forcing, and feedback
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );


% reconstruction of all 16 mse transports from Ntoa
mse_Ntoa_all=[enflux_ref_fromtoa(1,latind); cumsum(enflux_fromtoa(:,latind))+enflux_ref_fromtoa(1,latind)];

% subtract off Earthlike reference
plot(ts_gl(1:end),mse_Ntoa_all-mse_Ntoa_all(ref_ind),'ko-')
hold on;

% reconstruction of all 16 forcing transports
% in text number dts_gl'\cc  percent .0627/mse_Ntoa_all(ref_ind)
enflux_forcing=[enflux_ref_fromtoa(1,latind); cumsum(enflux_rf(:,latind))+enflux_ref_fromtoa(1,latind);]; 
plot(ts_gl(1:end),enflux_forcing-enflux_forcing(ref_ind),'bo-') ;

% reconstruction of all 16 feedback transports
enflux_feedback=[0; cumsum(enflux_fdbk(:,latind))];
hold on;plot(ts_gl(1:end),enflux_feedback-enflux_feedback(ref_ind),'co-')
plot(ts_gl(ref_ind),0,'bo-','markerfacecolor','b') ;

legend('GCM','','\lambda','location','nw'); legend boxoff;
h=text(269,1.15,'$\mathcal{F}$','fontsize',10); set(h,'Interpreter','latex');
axis([255 320 ymin ymax])
title('Forcing & Feedback','fontweight','bold')
set(gca,'box','off','xtick',[260:10:320],'xticklabel',{''})
ylabel('\Delta Energy Transport (PW)','fontweight','bold')
text(249,ymax*1.1,'a','fontweight','bold','fontsize',11);

subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

% reconstruction of all 16 Planck feedback transports
enflux_planck_feedback=[0; cumsum(enflux_planck(:,latind))];
enflux_lr_feedback=[0; cumsum(enflux_lr(:,latind))];

plot(ts_gl(1:end),enflux_feedback-enflux_feedback(ref_ind),'co-')
hold on;
plot(ts_gl(1:end),enflux_planck_feedback-enflux_planck_feedback(ref_ind),'mo-')
plot(ts_gl(1:end),enflux_lr_feedback-enflux_lr_feedback(ref_ind),'ro-')
plot(ts_gl(ref_ind),0,'ro-','markerfacecolor','r')

axis([255 320 ymin ymax])
title('Feedback Decomposition','fontweight','bold')
set(gca,'box','off','xtick',[260:10:320],'xticklabel',{''})
legend('\lambda','P','LR','location','s'); legend boxoff;
text(249,ymax*1.1,'b','fontweight','bold','fontsize',11);


subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,enflux_planck_feedback-enflux_planck_feedback(ref_ind),'mo-')
hold on;

% uniform temperature change Planck fdbck has opposite
% sensitivity as patterned temperature change
% and no structure over wide range of climates
enflux_planck_feedback_uniwarming=[0; cumsum(enflux_planck_uniwarming(:,latind))];
plot(ts_gl,enflux_planck_feedback_uniwarming-enflux_planck_feedback_uniwarming(ref_ind),'m--')

% using a fixed pattern of warming from abs1.4-abs1.0,
% there is an increase that captures all but the
% extreme climates
enflux_planck_feedback_fixedpat=[0; cumsum(enflux_planck_fixedpatternwarming(:,latind))];
plot(ts_gl,enflux_planck_feedback_fixedpat-enflux_planck_feedback_fixedpat(ref_ind),'m-')

enflux_planck_feedback_mebm=[0; cumsum(enflux_planck_mebm_est(:,latind))];
plot(ts_gl,enflux_planck_feedback_mebm-enflux_planck_feedback_mebm(ref_ind),'m:'); %,'color',gray);
plot(ts_gl(ref_ind),0,'mo-','markerfacecolor','m')

axis([255 320 ymin ymax])
title('Planck Feedback','fontweight','bold')
set(gca,'box','off','xtick',[260:10:320])
ylabel('\Delta Energy Transport (PW)','fontweight','bold')
xlabel('Surface Temperature (K)','fontweight','bold')
text(249,ymax*1.1,'c','fontweight','bold','fontsize',11);
legend('P','\Delta T uni','\Delta T const','no GCM est','location','se'); legend boxoff;


subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );


plot(ts_gl(1:end),enflux_lr_feedback-enflux_lr_feedback(ref_ind),'ro-')
hold on;

% uniform temperature change LR fdbck has similar 
% sensitivity as patterned temperature change
enflux_lr_feedback_uniwarming=[0; cumsum(enflux_lr_uniwarming(:,latind))];
plot(ts_gl,enflux_lr_feedback_uniwarming-enflux_lr_feedback_uniwarming(ref_ind),'r--')

enflux_lr_feedback_fixedpatternwarming=[0; cumsum(enflux_lr_fixedpatternwarming(:,latind))];
plot(ts_gl,enflux_lr_feedback_fixedpatternwarming-enflux_lr_feedback_fixedpatternwarming(ref_ind),'r-')

enflux_lr_feedback_ma_uniwarming=[0; cumsum(enflux_lr_ma_uniwarming(:,latind))];
plot(ts_gl,enflux_lr_feedback_ma_uniwarming-enflux_lr_feedback_ma_uniwarming(ref_ind),'r:') %,'color',gray);

plot(ts_gl(ref_ind),0,'ro-','markerfacecolor','r')

axis([255 320 ymin ymax])
title('Lapse Rate Feedback','fontweight','bold')
set(gca,'box','off','xtick',[260:10:320]);
xlabel('Surface Temperature (K)','fontweight','bold')
text(249,ymax*1.1,'d','fontweight','bold','fontsize',11);
legend('LR','\Delta T uni','\Delta T const','no GCM est', 'location','s'); legend boxoff;


print -depsc rad_vs_diff_figs/fig4.eps
end


if 1
%--------------------------------------------------------------------
% Fig. 5: 
%   wide range of warming pattern, LR feedback, and tot feedback
% with CCSM3
%--------------------------------------------------------------------

gray = [0.6 0.6 0.6];
clf; init_figure;
fwidth          = 6.5;
fheight         = fwidth / 1.618*3/2;
loff            = 0.08;
roff            = 0.02;
boff            = .07;
toff            = .04;
hdist           = 0.09;
cbar_width      = 0.0;
vdist           = hdist * fwidth / fheight*.7;
panel_width     = (1-roff-loff-1*hdist)/2;
panel_height    = (1-boff-toff-2*vdist)/3;

set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');


ymaxtoa = 6;
ymintoa = -8;
ymaxflux = 2.5;
yminflux = -4;


% top row: wide range of total feedback parameter

% gray on left
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );


sim_inds = [1:2:15];

for k = 1:length(sim_inds)

  if k<5
    plot_col(k,:) = [0.2*(k) 0.2*(k) 1.0];
    if k==1  plot_col(k,:) = [0.2*(k) 0.2*(k) 0.8]; end
  else
    dTcolmax = ts_gl_cam3(end)-ts_gl_cam3(1);
    color2 = (((ts_gl(sim_inds(k))-ts_gl(ref_ind)) )./dTcolmax).^.6;
    plot_col(k,:) = [1.0 1.0-color2 1.0-color2];
  end

  plot(lat,total_fdbk_all(sim_inds(k),:),'-','color',plot_col(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 -8.5 -2])
text(-115,-2,'a','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
title('Total Feedback, Gray','fontweight','bold');
ylabel('W m^{-2} K^{-1}','fontweight','bold')

% CCSM3 on right
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

for k = 2:length(co2_cam3)

% use same upper bound as gray
  color2 = (((ts_gl_cam3(k)-ts_gl_cam3(1)) )./dTcolmax).^.6;
  plot_col_cam3(k,:) = [1.0 1.0-color2 1.0-color2];
  
  plot(lat_cam3,total_fdbk_cam3(:,k-1),'-','color',plot_col_cam3(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 -4.5 1.2])
text(-115,1.2,'b','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
title('Total Feedback, CCSM3','fontweight','bold');
ylabel('W m^{-2} K^{-1}','fontweight','bold')


% middle panels are LR feedback structure

% gray on left
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );


%sim_inds = [1:2:15];

for k = 1:length(sim_inds)
  plot(lat,lr_fdbk_all(sim_inds(k),:),'-','color',plot_col(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 -4 1.5])
text(-115,1.5,'c','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
title('Lapse Rate Feedback, Gray','fontweight','bold');
ylabel('W m^{-2} K^{-1}','fontweight','bold')

% CCSM3 on right
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

for k = 2:length(co2_cam3)
  plot(lat_cam3,lapse_cam3(:,k-1),'-','color',plot_col_cam3(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 -2.5 1.65])
text(-115,1.65,'d','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90],'xticklabel',{''});
title('Lapse Rate Feedback, CCSM3','fontweight','bold');
ylabel('W m^{-2} K^{-1}','fontweight','bold')


% bottom row is temperature structure

% gray on left
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );


%sim_inds = [1:2:15];

for k = 1:length(sim_inds)
  dsat_gl = ts_gl(sim_inds(k)+1)-ts_gl(sim_inds(k));
  plot(lat,dsat_all(sim_inds(k),:)./dsat_gl,'-','color',plot_col(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 0 3.5])
text(-115,3.5,'e','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90]);
title('Temperature Change, Gray','fontweight','bold');
ylabel('K K^{-1}','fontweight','bold')
xlabel('Latitude','fontweight','bold')

% CCSM3 on right
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

for k = 2:length(co2_cam3)
  plot(lat_cam3,dT_cam3(:,k-1),'-','color',plot_col_cam3(k,:));
  hold on;
end

plot(lat, zeros(size(lat)),'k:');
axis([-90 90 0 3.5])
text(-115,3.5,'f','fontweight','bold','fontsize',11);
set(gca,'box','off','xtick',[-90:30:90]);
title('Temperature Change, CCSM3','fontweight','bold');
ylabel('K K^{-1}','fontweight','bold')
xlabel('Latitude','fontweight','bold')

print -depsc rad_vs_diff_figs/fig5.eps


end

% ---------
%  Fig. 6 three by three panel diffusive component plot
% ---------

% note, there's an additional T dep in beta that's not shown in subcomp plots
% this is a 20% variation over range of cliamtes
% and appox using ts_gl fine to reconstruct beta from plotted H, gamma

clf; init_figure;
fwidth          = 6.5;
fheight         = fwidth*1.3 / 1.618;
loff            = 0.08;
roff            = 0.02;
boff            = .08;
toff            = .05;
hdist           = 0.06;
cbar_width      = 0.0;
vdist           = 0.08;
panel_width     = (1-roff-loff-2*hdist)/3;
panel_height    = (1-boff-toff-2*vdist)/3;

set(gcf, 'Units', 'inches', 'PaperUnits', 'inches');
psize           = get(gcf, 'PaperSize');
fpos            = get(gcf, 'Position');
ppos            = [(psize(1) - fwidth)/2, (psize(2) - fheight)/2, ...
                                      fwidth, fheight];
fpos            = [fpos(1) fpos(2) fpos(3) fpos(3)*fheight/ ...
                       fwidth];

set(gcf, 'PaperPosition', ppos, ...
    'Position', fpos, ...
    'DefaultAxesFontSize', 11, ...
    'DefaultLineLineWidth', 1.25, ...
    'DefaultLineMarkerSize',6.0, ...
    'DefaultAxesLineWidth', 1.5, ...
    'DefaultAxesTickDir', 'out', ...
    'DefaultAxesTickLength', [0.015 0.015], ...
    'DefaultAxesXMinorTick', 'off', ...
    'DefaultAxesYMinorTick', 'off', ...
    'DefaultAxesLayer', 'top');

ymax = 160;
ymax_big = 610;

% total diffusive scaling
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,(mse_flux(:,latind)./mse_flux(ref_ind,latind))*100,'ko-')
hold on;
plot(ts_gl,(mse_flux_diff./mse_flux_diff(ref_ind))*100,'-','color',gray)
%plot(ts_gl,latent_flux(:,latind),'b-.')
%plot(ts_gl,mse_flux(:,latind)-latent_flux(:,latind),'r--')
plot(ts_gl(ref_ind),100,'ko','markerfacecolor','k')
%plot(ts_gl(ref_ind),mse_flux(ref_ind,latind),'ko','markerfacecolor','k')
axis([255 320 0 ymax])
title('Energy Transport','fontweight','bold')
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:150])
set(gca,'xticklabel',{''})
%grid on;
text(258,ymax*.95,'a','fontweight','bold','fontsize',11);
ylabel('%','fontweight','bold')
xlabel('','fontweight','bold')
legend('GCM','BS14','location','se');  legend boxoff;


% dry parts alpha veddy delT of  diffusive scaling
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

alpha_veddy_delT = mean_grad_comp_dry.*veddy;
plot(ts_gl,(alpha_veddy_delT./alpha_veddy_delT(ref_ind))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:150])
set(gca,'xticklabel',{''})
text(258,ymax*.95,'b','fontweight','bold','fontsize',11);
titlestr = '\alpha v_{e} \Delta_h T';
title(titlestr,'Interpreter','tex');
xlabel('','fontweight','bold')


% modification of diff scaling from latent: 1+beta qs
subplot('Position', [loff+2*(panel_width+hdist),...
                         boff+2*(panel_height+vdist), ...
                         panel_width, panel_height ] );

latent_mod = (1+beta.*qsat_ref);

plot(ts_gl,(latent_mod./latent_mod(ref_ind))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 210])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200]);
set(gca,'xticklabel',{''});
text(258,210*.95,'c','fontweight','bold','fontsize',11);
titlestr = '1 + \beta q_s ';
title(titlestr,'Interpreter','tex');
xlabel('','fontweight','bold')

% storm track lat componentn cos phi_s 
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,cos(eke_lat*pi/180)./cos(eke_lat(ref_ind)*pi/180))


plot(ts_gl,(cos(eke_lat*pi/180)./cos(eke_lat(ref_ind)*pi/180))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200]);
set(gca,'xticklabel',{''});
text(258,ymax*.95,'d','fontweight','bold','fontsize',11);
titlestr = 'cos(\phi_s)';
title(titlestr,'Interpreter','tex');
xlabel('','fontweight','bold')
ylabel('%','fontweight','bold')

% veddy component
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );


plot(ts_gl,(veddy./veddy(ref_ind))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200]);
set(gca,'xticklabel',{''});
text(258,ymax*.95,'e','fontweight','bold','fontsize',11);
titlestr = 'v_{e}';
title(titlestr,'Interpreter','tex');
xlabel('','fontweight','bold')


% delT component
subplot('Position', [loff+2*(panel_width+hdist),...
                         boff+1*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,(delT./delT(ref_ind))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200]);
set(gca,'xticklabel',{''});
text(258,ymax*.95,'f','fontweight','bold','fontsize',11);
titlestr = '\Delta_h T';
title(titlestr,'Interpreter','tex');

% qsat component
subplot('Position', [loff+0*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );


plot(ts_gl,qsat_ref./qsat_ref(ref_ind)*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax_big])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:100:600])
text(258,ymax_big*.95,'g','fontweight','bold','fontsize',11);
titlestr = 'q_{s}';
title(titlestr,'Interpreter','tex');
xlabel('Surface Temperature (K)','fontweight','bold')
ylabel('%','fontweight','bold')

% RH component
subplot('Position', [loff+1*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );


plot(ts_gl,(rh_subtrop./rh_subtrop(ref_ind))*100,'-','color',gray)
hold on; plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200])
text(258,ymax*.95,'h','fontweight','bold','fontsize',11);
titlestr = '$\mathcal{H}$';
title(titlestr,'Interpreter','latex');
xlabel('Surface Temperature (K)','fontweight','bold')


% gamma component
subplot('Position', [loff+2*(panel_width+hdist),...
                         boff+0*(panel_height+vdist), ...
                         panel_width, panel_height ] );

plot(ts_gl,(gamma./gamma(ref_ind))*100,'-','color',gray);
hold on;
plot(ts_gl(ref_ind),100,'o','color',gray,'markerfacecolor',gray)
axis([255 320 0 ymax])
set(gca,'box','off','xtick',[260:10:320],'ytick',[0:50:200])
text(258,ymax*.95,'i','fontweight','bold','fontsize',11);
titlestr = '$\hat{\Gamma}$';
title(titlestr,'Interpreter','latex');
xlabel('Surface Temperature (K)','fontweight','bold')


if use_eke_bl
  print -depsc rad_vs_diff_figs/fig6_ekebl.eps
else
  print -depsc rad_vs_diff_figs/fig6.eps
end





